<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.mulcan package &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="_static/doctools.js"></script>
        <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="scripts.multiple_candidates.scripts_ana package" href="scripts.multiple_candidates.scripts_ana.html" />
    <link rel="prev" title="scripts.multiple_candidates.definition package" href="scripts.multiple_candidates.definition.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="lib.html">lib package</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="scripts.html">scripts.multiple_candidates package</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="scripts.html#multiple-candidates">Multiple candidates</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="scripts.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="scripts.multiple_candidates.definition.html">scripts.multiple_candidates.definition package</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">scripts.multiple_candidates.mulcan package</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#module-scripts.multiple_candidates.mulcan.common_features">scripts.multiple_candidates.mulcan.common_features module</a></li>
<li class="toctree-l4"><a class="reference internal" href="#module-scripts.multiple_candidates.mulcan.events">scripts.multiple_candidates.mulcan.events module</a></li>
<li class="toctree-l4"><a class="reference internal" href="#module-scripts.multiple_candidates.mulcan.parser">scripts.multiple_candidates.mulcan.parser module</a></li>
<li class="toctree-l4"><a class="reference internal" href="#module-scripts.multiple_candidates.mulcan.particles">scripts.multiple_candidates.mulcan.particles module</a></li>
<li class="toctree-l4"><a class="reference internal" href="#module-scripts.multiple_candidates.mulcan.root_files">scripts.multiple_candidates.mulcan.root_files module</a></li>
<li class="toctree-l4"><a class="reference internal" href="#module-scripts.multiple_candidates.mulcan.strategy">scripts.multiple_candidates.mulcan.strategy module</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="scripts.html#scripts">Scripts</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="scripts.html">scripts.multiple_candidates package</a> &raquo;</li>
      <li>scripts.multiple_candidates.mulcan package</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/scripts.multiple_candidates.mulcan.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <div class="section" id="module-scripts.multiple_candidates.mulcan">
<span id="scripts-multiple-candidates-mulcan-package"></span><h1>scripts.multiple_candidates.mulcan package<a class="headerlink" href="#module-scripts.multiple_candidates.mulcan" title="Permalink to this heading"></a></h1>
<p>This small package contains functions used locally to deal with
multiple candidates. It does not handle plots or general-purpose operations.</p>
<div class="section" id="module-scripts.multiple_candidates.mulcan.common_features">
<span id="scripts-multiple-candidates-mulcan-common-features-module"></span><h2>scripts.multiple_candidates.mulcan.common_features module<a class="headerlink" href="#module-scripts.multiple_candidates.mulcan.common_features" title="Permalink to this heading"></a></h2>
<p>Module to find the shared features between multiples candidates.</p>
<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.common_features.array_feature_flags_into_features">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.common_features.</span></span><span class="sig-name descname"><span class="pre">array_feature_flags_into_features</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">array_possible_feature_flags</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_features</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/common_features.html#array_feature_flags_into_features"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.common_features.array_feature_flags_into_features" title="Permalink to this definition"></a></dt>
<dd><p>Convert the array of array of booleans, each boolean corresponding to
a flag to tell if the feature is shared or not, into a list of list
of the features that are shared.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>array_shared_features</strong> – array of an array of booleans,
each boolean corresponding to one of the feature. Thus, one row of
this array corresponds to a possible set of common features,
encoded by an array of booleans.</p></li>
<li><p><strong>list_features</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – list of the name of the features corresponding to
the columns of <code class="docutils literal notranslate"><span class="pre">array_shared_features</span></code></p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>list of list of features that were flagged in <code class="docutils literal notranslate"><span class="pre">array_shared_features</span></code></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.common_features.count_shared_features">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.common_features.</span></span><span class="sig-name descname"><span class="pre">count_shared_features</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">df_shared_feature_flags</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_features</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">sort</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/common_features.html#count_shared_features"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.common_features.count_shared_features" title="Permalink to this definition"></a></dt>
<dd><p>Get the possible shared features between multiple candidates,
and their yields.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>df_shared_feature_flags</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – indices are <code class="docutils literal notranslate"><span class="pre">event_column</span></code> and the
combination number <code class="docutils literal notranslate"><span class="pre">comb</span></code>, and columns are the features given
in <code class="docutils literal notranslate"><span class="pre">dict_features</span></code>. The values are booleans, and their values
indicate wether the feature is shared between a combination
of 2 candidates</p></li>
<li><p><strong>features</strong> – list of features. If not given, directly taken as the
columns of <code class="docutils literal notranslate"><span class="pre">df_shared_feature_flags</span></code></p></li>
<li><p><strong>sort</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code>]) – whether to sort the shared features by the number
that was found.</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">array</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><ul class="simple">
<li><p>list_possible_shared_features: possible list of features that         are simultaneously shared by the combination of 2 features</p></li>
<li><p>array_shared_feature_yields: corresponding yields (aka number         of combinations that were observed)</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.common_features.find_shared_features_given_mult">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.common_features.</span></span><span class="sig-name descname"><span class="pre">find_shared_features_given_mult</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataframe</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">series_event_mults</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mult</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dict_features</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">event_column</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'runNumber_eventNumber'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">event_columns</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">['runNumber',</span> <span class="pre">'eventNumber',</span> <span class="pre">'year',</span> <span class="pre">'magnet']</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">check_all_shared</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">check_nothing_shared</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/common_features.html#find_shared_features_given_mult"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.common_features.find_shared_features_given_mult" title="Permalink to this definition"></a></dt>
<dd><p>Find the shared features of a dataframe, for a given multiplicity
<code class="docutils literal notranslate"><span class="pre">mult</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – full sample</p></li>
<li><p><strong>series_event_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>) – Indices are the event numbers, and values are
the associated number of candidates. OR can also be a dictionnary
that associates a multiplicity with the list of events.
(This is ugly but practical just to assure that the code
works both in the notebook and python script.)</p></li>
<li><p><strong>mult</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – candidate multiplicity of each event</p></li>
<li><p><strong>dict_features</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Dict</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>, <code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]]]) – associates a name of features with a column, or a
list a columns that must be all equal, for 2 candidates
to be declared to share the same features</p></li>
<li><p><strong>event_column</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – name of the column that allows to identify an event</p></li>
<li><p><strong>event_columns</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – list of columns <code class="docutils literal notranslate"><span class="pre">event_column</span></code> corresponds to</p></li>
<li><p><strong>check_all_shared</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code>) – individually check the events that share all
the features given in <code class="docutils literal notranslate"><span class="pre">dict_features</span></code></p></li>
<li><p><strong>check_nothing_shared</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code>) – individually check the events that share all
the features given in <code class="docutils literal notranslate"><span class="pre">dict_features</span></code></p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>indices are <code class="docutils literal notranslate"><span class="pre">event_column</span></code> and the combination number <code class="docutils literal notranslate"><span class="pre">comb</span></code>,
and columns are the features given in <code class="docutils literal notranslate"><span class="pre">dict_features</span></code>.
The values are booleans, and their values indicate whether
the feature is shared between a combination of 2 candidates</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.common_features.get_index_combination">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.common_features.</span></span><span class="sig-name descname"><span class="pre">get_index_combination</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">mult</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/common_features.html#get_index_combination"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.common_features.get_index_combination" title="Permalink to this definition"></a></dt>
<dd><p>Compute the combination numbers to assign to each candidate.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>mult</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – candidate multiplicity</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>Associates a two-dimensional array, with one row for each of the
<code class="docutils literal notranslate"><span class="pre">mult</span></code> candidate multiplicty, and one column for each copy of
the <code class="docutils literal notranslate"><span class="pre">mult</span> <span class="pre">-</span> <span class="pre">1</span></code> copies of the  candidates.</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>Say we want to find all the possible combinations of <code class="docutils literal notranslate"><span class="pre">mult</span></code>
candidates in a vectorised way.</p>
<p>What we can do is define a variable <code class="docutils literal notranslate"><span class="pre">comb</span></code> which is an index of
the <cite>2 choose mult</cite> possible combinations. Thus, <code class="docutils literal notranslate"><span class="pre">comb</span></code>
is an integer ranging from 1 to <code class="docutils literal notranslate"><span class="pre">comb</span></code>.</p>
<p>Then, we will use <code class="docutils literal notranslate"><span class="pre">groupby</span></code> on <code class="docutils literal notranslate"><span class="pre">comb</span></code> in order to gather the
candidates with the same value of <code class="docutils literal notranslate"><span class="pre">comb</span></code> together. Since we need
<code class="docutils literal notranslate"><span class="pre">2</span> <span class="pre">choose</span> <span class="pre">comb</span></code> combinations, we need <code class="docutils literal notranslate"><span class="pre">2</span> <span class="pre">*</span> <span class="pre">(`2</span> <span class="pre">choose</span> <span class="pre">comb`)</span></code>
candidates, and we already have <code class="docutils literal notranslate"><span class="pre">comb</span></code> candidates.
We thus need to duplicate the sample
<code class="docutils literal notranslate"><span class="pre">2</span> <span class="pre">*</span> <span class="pre">(`2</span> <span class="pre">choose</span> <span class="pre">comb`)</span> <span class="pre">/</span> <span class="pre">comb</span> <span class="pre">=</span> <span class="pre">comb</span> <span class="pre">-</span> <span class="pre">1</span></code> times only.</p>
<p>For instance, for <code class="docutils literal notranslate"><span class="pre">mult</span> <span class="pre">=</span> <span class="pre">3</span></code> (3 candidates), there are 3 possible
combinations.
<code class="docutils literal notranslate"><span class="pre">comb</span> <span class="pre">=</span> <span class="pre">1</span></code> corresponds to the combination of the 1st candidate with
the 2nd one, <code class="docutils literal notranslate"><span class="pre">comb</span> <span class="pre">=</span> <span class="pre">2</span></code>, is the combination of the 1st candidate
and the 3rd candidate, Finally <code class="docutils literal notranslate"><span class="pre">comb</span> <span class="pre">=</span> <span class="pre">3</span></code> corresponds to the last
combination of the 2nd or the 3rd candidate. We well also need
to duplicate the sample <code class="docutils literal notranslate"><span class="pre">mult</span> <span class="pre">-</span> <span class="pre">1</span> <span class="pre">=</span> <span class="pre">2</span></code> times (so just the original
and 1 copy).</p>
<p>It is hightly possible there is a less weird way to do this …</p>
</dd></dl>

</div>
<div class="section" id="module-scripts.multiple_candidates.mulcan.events">
<span id="scripts-multiple-candidates-mulcan-events-module"></span><h2>scripts.multiple_candidates.mulcan.events module<a class="headerlink" href="#module-scripts.multiple_candidates.mulcan.events" title="Permalink to this heading"></a></h2>
<p>Module to get the events with multiple or single candidates</p>
<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.events.compute_ratio_multiple">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.events.</span></span><span class="sig-name descname"><span class="pre">compute_ratio_multiple</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">series_event_mults</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/events.html#compute_ratio_multiple"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.events.compute_ratio_multiple" title="Permalink to this definition"></a></dt>
<dd><p>Compute <span class="math notranslate nohighlight">\(R_{\text{R_all}}\)</span>, the fraction of events with
multiple candidates.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>series_event_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>) – Indices are the event numbers, and values are
the associated number of candidates</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">ufloat</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>proportion of events with multiple candidates</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.events.get_dataframe_multiple_candidates">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.events.</span></span><span class="sig-name descname"><span class="pre">get_dataframe_multiple_candidates</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataframe</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">series_event_mults</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">event_column</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/events.html#get_dataframe_multiple_candidates"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.events.get_dataframe_multiple_candidates" title="Permalink to this definition"></a></dt>
<dd><p>Get the dataframe of events with multiple candidates</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – sample</p></li>
<li><p><strong>series_event_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>) – Indices are the event numbers, and values are
the associated number of candidates</p></li>
<li><p><strong>event_column</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – column name used to distinguish one event from another</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>dataframe of multiple candidates</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.events.get_dataframe_single_candidates">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.events.</span></span><span class="sig-name descname"><span class="pre">get_dataframe_single_candidates</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataframe</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">series_event_mults</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">event_column</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/events.html#get_dataframe_single_candidates"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.events.get_dataframe_single_candidates" title="Permalink to this definition"></a></dt>
<dd><p>Get the dataframe of events with multiple candidates</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – sample</p></li>
<li><p><strong>series_event_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>) – Indices are the event numbers, and values are
the associated number of candidates</p></li>
<li><p><strong>event_column</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – column name used to distinguish one event from another</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>dataframe of multiple candidates</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.events.get_dataframe_with_given_mult">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.events.</span></span><span class="sig-name descname"><span class="pre">get_dataframe_with_given_mult</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataframe</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">series_event_mults</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">event_column</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mult</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/events.html#get_dataframe_with_given_mult"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.events.get_dataframe_with_given_mult" title="Permalink to this definition"></a></dt>
<dd><p>Get the dataframe of events with multiple candidates</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – sample</p></li>
<li><p><strong>series_event_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>) – Indices are the event numbers, and values are
the associated number of candidates</p></li>
<li><p><strong>event_column</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – column name used to distinguish one event from another</p></li>
<li><p><strong>mult</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – candidatem multiplicity required</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>dataframe of events with multiplicity <code class="docutils literal notranslate"><span class="pre">mult</span></code></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.events.get_event_multiplicities">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.events.</span></span><span class="sig-name descname"><span class="pre">get_event_multiplicities</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataframe</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">event_column</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/events.html#get_event_multiplicities"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.events.get_event_multiplicities" title="Permalink to this definition"></a></dt>
<dd><dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – data sample, must contain the column <code class="docutils literal notranslate"><span class="pre">event_column</span></code></p></li>
<li><p><strong>event_column</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – name of the column that allows to identify an event</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>Indices are the event numbers, and values are the associated
number of candidates</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.events.get_events_with_given_mult">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.events.</span></span><span class="sig-name descname"><span class="pre">get_events_with_given_mult</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">series_event_mults</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mult</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/events.html#get_events_with_given_mult"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.events.get_events_with_given_mult" title="Permalink to this definition"></a></dt>
<dd><p>Get the list of events with a given number of candidates</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>series_event_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>) – indices are the event numbers,
and values are the associated number of candidates.
Use the function <a class="reference internal" href="#scripts.multiple_candidates.mulcan.events.get_event_multiplicities" title="scripts.multiple_candidates.mulcan.events.get_event_multiplicities"><code class="xref py py-func docutils literal notranslate"><span class="pre">get_event_multiplicities()</span></code></a> to get it.</p></li>
<li><p><strong>mult</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – candidate multiplicity</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">array</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>arrays of event numbers with single candidates</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.events.get_events_with_multiple_candidates">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.events.</span></span><span class="sig-name descname"><span class="pre">get_events_with_multiple_candidates</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">series_event_mults</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/events.html#get_events_with_multiple_candidates"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.events.get_events_with_multiple_candidates" title="Permalink to this definition"></a></dt>
<dd><p>Get the list of events with multiple candidates (that we’ll call
multiple events, for short)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>series_event_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>) – indices are the event numbers,
and values are the associated number of candidates.
Use the function <a class="reference internal" href="#scripts.multiple_candidates.mulcan.events.get_event_multiplicities" title="scripts.multiple_candidates.mulcan.events.get_event_multiplicities"><code class="xref py py-func docutils literal notranslate"><span class="pre">get_event_multiplicities()</span></code></a> to get it.</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">array</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>arrays of event numbers with multiple candidates</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.events.get_events_with_single_candidates">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.events.</span></span><span class="sig-name descname"><span class="pre">get_events_with_single_candidates</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">series_event_mults</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/events.html#get_events_with_single_candidates"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.events.get_events_with_single_candidates" title="Permalink to this definition"></a></dt>
<dd><p>Get the list of events with only one candidate (that we’ll call
single events, for short)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>series_event_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>) – indices are the event numbers,
and values are the associated number of candidates.
Use the function <a class="reference internal" href="#scripts.multiple_candidates.mulcan.events.get_event_multiplicities" title="scripts.multiple_candidates.mulcan.events.get_event_multiplicities"><code class="xref py py-func docutils literal notranslate"><span class="pre">get_event_multiplicities()</span></code></a> to get it.</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">array</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>arrays of event numbers with single candidates</p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-scripts.multiple_candidates.mulcan.parser">
<span id="scripts-multiple-candidates-mulcan-parser-module"></span><h2>scripts.multiple_candidates.mulcan.parser module<a class="headerlink" href="#module-scripts.multiple_candidates.mulcan.parser" title="Permalink to this heading"></a></h2>
<p>Module to generate and get the output of a parser.</p>
<dl class="py data">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.parser.dict_predefined_parse_args">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.parser.</span></span><span class="sig-name descname"><span class="pre">dict_predefined_parse_args</span></span><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">{'base_seed':</span> <span class="pre">[('s',</span> <span class="pre">'seed'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'default':</span> <span class="pre">15,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'int'&gt;,</span> <span class="pre">'help':</span> <span class="pre">'seed</span> <span class="pre">to</span> <span class="pre">choose</span> <span class="pre">randomly</span> <span class="pre">one</span> <span class="pre">multiple</span> <span class="pre">candidate'}],</span> <span class="pre">'eosdir':</span> <span class="pre">[('d',</span> <span class="pre">'eosdir'),</span> <span class="pre">{'default':</span> <span class="pre">'/eos/lhcb/user/a/anthonyc/R_eMu/CentralProduction5_-1files',</span> <span class="pre">'required':</span> <span class="pre">False,</span> <span class="pre">'help':</span> <span class="pre">'Path</span> <span class="pre">to</span> <span class="pre">the</span> <span class="pre">main</span> <span class="pre">EOS</span> <span class="pre">directory'}],</span> <span class="pre">'ffmodel':</span> <span class="pre">[('f',</span> <span class="pre">'ffmodel'),</span> <span class="pre">{'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'default':</span> <span class="pre">'CLN',</span> <span class="pre">'required':</span> <span class="pre">False,</span> <span class="pre">'choices':</span> <span class="pre">['CLN',</span> <span class="pre">'BGL'],</span> <span class="pre">'help':</span> <span class="pre">'FF</span> <span class="pre">model</span> <span class="pre">for</span> <span class="pre">signal'}],</span> <span class="pre">'flavour':</span> <span class="pre">[('f',</span> <span class="pre">'flavour'),</span> <span class="pre">{'required':</span> <span class="pre">True,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'choices':</span> <span class="pre">['Electron',</span> <span class="pre">'Mu'],</span> <span class="pre">'help':</span> <span class="pre">'Which</span> <span class="pre">flavour</span> <span class="pre">to</span> <span class="pre">analyse'}],</span> <span class="pre">'full_muc_strat':</span> <span class="pre">[('full_strat',</span> <span class="pre">'full_strategy'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'default':</span> <span class="pre">'all',</span> <span class="pre">'help':</span> <span class="pre">'Full</span> <span class="pre">strategy</span> <span class="pre">to</span> <span class="pre">deal</span> <span class="pre">with</span> <span class="pre">multiple</span> <span class="pre">candidates'}],</span> <span class="pre">'indir':</span> <span class="pre">[('i',</span> <span class="pre">'indir'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'default':</span> <span class="pre">'/eos/lhcb/user/a/anthonyc/R_eMu/CentralProduction5_-1files/selection',</span> <span class="pre">'help':</span> <span class="pre">'path</span> <span class="pre">to</span> <span class="pre">the</span> <span class="pre">output</span> <span class="pre">directory</span> <span class="pre">of</span> <span class="pre">JSON/PNG/PDF/PICKLE</span> <span class="pre">files'}],</span> <span class="pre">'inpath':</span> <span class="pre">[('i',</span> <span class="pre">'inpath'),</span> <span class="pre">{'required':</span> <span class="pre">True,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'help':</span> <span class="pre">'path</span> <span class="pre">to</span> <span class="pre">the</span> <span class="pre">input</span> <span class="pre">ROOT</span> <span class="pre">file'}],</span> <span class="pre">'muc_strat':</span> <span class="pre">[('strat',</span> <span class="pre">'strategy'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'choices':</span> <span class="pre">['sc',</span> <span class="pre">'random',</span> <span class="pre">'opt'],</span> <span class="pre">'default':</span> <span class="pre">'sc',</span> <span class="pre">'help':</span> <span class="pre">'Strategy</span> <span class="pre">to</span> <span class="pre">deal</span> <span class="pre">with</span> <span class="pre">multiple</span> <span class="pre">candidates'}],</span> <span class="pre">'mulcan':</span> <span class="pre">[('m',</span> <span class="pre">'mulcan'),</span> <span class="pre">{'default':</span> <span class="pre">'',</span> <span class="pre">'required':</span> <span class="pre">False,</span> <span class="pre">'nargs':</span> <span class="pre">'?',</span> <span class="pre">'help':</span> <span class="pre">'Relative</span> <span class="pre">output</span> <span class="pre">directory</span> <span class="pre">that</span> <span class="pre">depends</span> <span class="pre">on</span> <span class="pre">how</span> <span class="pre">multiple</span> <span class="pre">candidates</span> <span class="pre">are</span> <span class="pre">handled'}],</span> <span class="pre">'noplot':</span> <span class="pre">[('np',</span> <span class="pre">'noplot'),</span> <span class="pre">{'help':</span> <span class="pre">'Do</span> <span class="pre">not</span> <span class="pre">produce</span> <span class="pre">any</span> <span class="pre">plots',</span> <span class="pre">'required':</span> <span class="pre">False,</span> <span class="pre">'action':</span> <span class="pre">'store_true'}],</span> <span class="pre">'opt_best':</span> <span class="pre">[('b',</span> <span class="pre">'opt_best'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'default':</span> <span class="pre">'min',</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'choices':</span> <span class="pre">['max',</span> <span class="pre">'min'],</span> <span class="pre">'help':</span> <span class="pre">'What</span> <span class="pre">is</span> <span class="pre">the</span> <span class="pre">&quot;best&quot;</span> <span class="pre">'}],</span> <span class="pre">'opt_column':</span> <span class="pre">[('c',</span> <span class="pre">'opt_column'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'default':</span> <span class="pre">None,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'help':</span> <span class="pre">'Optimised</span> <span class="pre">column</span> <span class="pre">for</span> <span class="pre">strategy</span> <span class="pre">`optimised`'}],</span> <span class="pre">'outdir':</span> <span class="pre">[('o',</span> <span class="pre">'outdir'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'default':</span> <span class="pre">'/afs/cern.ch/user/a/anthonyc/public/Semileptonics/scripts/multiple_candidates/output',</span> <span class="pre">'help':</span> <span class="pre">'path</span> <span class="pre">to</span> <span class="pre">the</span> <span class="pre">output</span> <span class="pre">directory</span> <span class="pre">of</span> <span class="pre">JSON/PNG/PDF/PICKLE</span> <span class="pre">files'}],</span> <span class="pre">'outpath':</span> <span class="pre">[('o',</span> <span class="pre">'outpath'),</span> <span class="pre">{'required':</span> <span class="pre">True,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'help':</span> <span class="pre">'path</span> <span class="pre">to</span> <span class="pre">the</span> <span class="pre">output</span> <span class="pre">ROOT</span> <span class="pre">file'}],</span> <span class="pre">'outpath_opt':</span> <span class="pre">[('o',</span> <span class="pre">'outpath'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'default':</span> <span class="pre">None,</span> <span class="pre">'help':</span> <span class="pre">'path</span> <span class="pre">to</span> <span class="pre">the</span> <span class="pre">output</span> <span class="pre">ROOT</span> <span class="pre">file'}],</span> <span class="pre">'preselectiondir':</span> <span class="pre">[('p',</span> <span class="pre">'preselectiondir'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'default':</span> <span class="pre">'root://eoslhcb.cern.ch//eos/lhcb/wg/semileptonic/R_eMu/CentralProduction5_-1files',</span> <span class="pre">'help':</span> <span class="pre">'Path</span> <span class="pre">to</span> <span class="pre">the</span> <span class="pre">directory</span> <span class="pre">of</span> <span class="pre">the</span> <span class="pre">preselected</span> <span class="pre">ROOT</span> <span class="pre">files'}],</span> <span class="pre">'sample_type':</span> <span class="pre">[('s',</span> <span class="pre">'sample_type'),</span> <span class="pre">{'required':</span> <span class="pre">False,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'default':</span> <span class="pre">'data',</span> <span class="pre">'choices':</span> <span class="pre">['data',</span> <span class="pre">'comb',</span> <span class="pre">'MC_B02Dstarl',</span> <span class="pre">'MC_B02Dstarl_Cocktail',</span> <span class="pre">'MC_B02Dstarl_DoubleCharm',</span> <span class="pre">'MC_B02Dstarl_HigherCocktail',</span> <span class="pre">'MC_B02Dstarl_Tau',</span> <span class="pre">'MC_Bplus2Dstarl_Cocktail',</span> <span class="pre">'MC_Bplus2Dstarl_DoubleCharm',</span> <span class="pre">'MC_Bplus2Dstarl_HigherCocktail',</span> <span class="pre">'MC_Bplus2Dstarl_Tau',</span> <span class="pre">'MC_Bs2Dstarl_Ds'],</span> <span class="pre">'help':</span> <span class="pre">'Type</span> <span class="pre">of</span> <span class="pre">sample'}],</span> <span class="pre">'tree_name':</span> <span class="pre">[('t',</span> <span class="pre">'tree_name'),</span> <span class="pre">{'required':</span> <span class="pre">True,</span> <span class="pre">'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'help':</span> <span class="pre">'Tree</span> <span class="pre">name</span> <span class="pre">in</span> <span class="pre">the</span> <span class="pre">input</span> <span class="pre">and</span> <span class="pre">output</span> <span class="pre">ROOT</span> <span class="pre">files'}],</span> <span class="pre">'year':</span> <span class="pre">[('y',</span> <span class="pre">'year'),</span> <span class="pre">{'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'required':</span> <span class="pre">True,</span> <span class="pre">'choices':</span> <span class="pre">['2016',</span> <span class="pre">'2017',</span> <span class="pre">'2018'],</span> <span class="pre">'help':</span> <span class="pre">'Year'}],</span> <span class="pre">'year_opt':</span> <span class="pre">[('y',</span> <span class="pre">'year'),</span> <span class="pre">{'type':</span> <span class="pre">&lt;class</span> <span class="pre">'str'&gt;,</span> <span class="pre">'default':</span> <span class="pre">None,</span> <span class="pre">'required':</span> <span class="pre">False,</span> <span class="pre">'choices':</span> <span class="pre">['2016',</span> <span class="pre">'2017',</span> <span class="pre">'2018'],</span> <span class="pre">'help':</span> <span class="pre">'Year.</span> <span class="pre">If</span> <span class="pre">not</span> <span class="pre">given,</span> <span class="pre">all</span> <span class="pre">the</span> <span class="pre">years</span> <span class="pre">are</span> <span class="pre">taken'}]}</span></em><a class="headerlink" href="#scripts.multiple_candidates.mulcan.parser.dict_predefined_parse_args" title="Permalink to this definition"></a></dt>
<dd><p>Dictionnary of predefined parser arguments</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.parser.get_result_gen_parser">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.parser.</span></span><span class="sig-name descname"><span class="pre">get_result_gen_parser</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">description</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_arguments</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dict_arguments</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">switches</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/parser.html#get_result_gen_parser"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.parser.get_result_gen_parser" title="Permalink to this definition"></a></dt>
<dd><p>Generate a parser and return its result.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>description</strong> (<em>str</em>) – description of the script that uses the parser</p></li>
<li><p><strong>list_arguments</strong> (<em>List</em><em>[</em><em>str</em><em>]</em>) – list of predefined arguments in the
dictionnary <code class="xref py py-mod docutils literal notranslate"><span class="pre">dict_predefined_arguments`</span></code></p></li>
<li><p><strong>switches</strong> (<em>List</em><em>[</em><em>dict</em><em>]</em>) – <p>List of dictionnary, each dictionnary
defines a parser using <code class="xref py py-func docutils literal notranslate"><span class="pre">lib.tools.parser.add_switch()</span></code>,
so you need the arguments</p>
<ul>
<li><p>name (str): name of the flag</p></li>
<li><p>description (str): description of what the flag does</p></li>
<li><p>short (optional): short name of the flag</p></li>
</ul>
</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>result of the argument parser</p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-scripts.multiple_candidates.mulcan.particles">
<span id="scripts-multiple-candidates-mulcan-particles-module"></span><h2>scripts.multiple_candidates.mulcan.particles module<a class="headerlink" href="#module-scripts.multiple_candidates.mulcan.particles" title="Permalink to this heading"></a></h2>
<p>Module to deal with list of particles.</p>
<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.particles.daughter_to_mother_particles">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.particles.</span></span><span class="sig-name descname"><span class="pre">daughter_to_mother_particles</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">list_particles</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dict_daughter_to_mother_particles</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">{('Dst_D0_K',</span> <span class="pre">'Dst_D0_pi'):</span> <span class="pre">'Dst_D0',</span> <span class="pre">('Dst_D0_K',</span> <span class="pre">'Dst_D0_pi',</span> <span class="pre">'Dst_pi'):</span> <span class="pre">'Dst',</span> <span class="pre">('Dst_D0_K',</span> <span class="pre">'Dst_D0_pi',</span> <span class="pre">'Dst_pi',</span> <span class="pre">'l'):</span> <span class="pre">'B0'}</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/particles.html#daughter_to_mother_particles"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.particles.daughter_to_mother_particles" title="Permalink to this definition"></a></dt>
<dd><p>Remove the daughter particles of a list of particles,
in order to only keep the mother particles, if all the daughter particles
are in the list of particles.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>list_particles</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>]) – list of particles</p></li>
<li><p><strong>dict_daughter_to_mother_particles</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">dict</span></code>) – associates a
tuple of daughter particle with just the mother particle</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>list of mother particles</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.particles.get_label_from_list_particles">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.particles.</span></span><span class="sig-name descname"><span class="pre">get_label_from_list_particles</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">list_particles</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dict_particle_labels</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">sep</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'\\n'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/particles.html#get_label_from_list_particles"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.particles.get_label_from_list_particles" title="Permalink to this definition"></a></dt>
<dd><p>Transform a list of particle into a long string indicating all
the particles.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>list_particles</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – list of particles.</p></li>
<li><p><strong>dict_particle_labels</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Dict</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – associates a particle name with its labels</p></li>
<li><p><strong>sep</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – what to put between the label of two particles in the long
string that is returned</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Long string that contains the list of the labels of the particles
in <cite>list_particles</cite></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.particles.get_list_columns">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.particles.</span></span><span class="sig-name descname"><span class="pre">get_list_columns</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dict_particle_observables</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/particles.html#get_list_columns"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.particles.get_list_columns" title="Permalink to this definition"></a></dt>
<dd><p>Get the list of columns related to particles from list of particles
and list of observables</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dict_particle_observables</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">Dict</span></code>[<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>, <code class="xref py py-data docutils literal notranslate"><span class="pre">Tuple</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]], <code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]]]]) – associates a particle or a tuple of
particles with a list of observables. The key can also
be <code class="docutils literal notranslate"><span class="pre">&quot;all&quot;</span></code> for all the particles, and <code class="docutils literal notranslate"><span class="pre">&quot;long&quot;</span></code> for
particles with long tracks (basically the final-state particles)</p></li>
<li><p><strong>**kwargs</strong> – same as <cite>dict_particle_observables</cite> but the
keys must be strings.</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>list of columns, which are the observables of the particles defined
by the dictionnary <code class="docutils literal notranslate"><span class="pre">dict_particle_observables</span></code></p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-scripts.multiple_candidates.mulcan.root_files">
<span id="scripts-multiple-candidates-mulcan-root-files-module"></span><h2>scripts.multiple_candidates.mulcan.root_files module<a class="headerlink" href="#module-scripts.multiple_candidates.mulcan.root_files" title="Permalink to this heading"></a></h2>
<p>Module to open the ROOT files of interest.</p>
<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.root_files.compute_endvertex_chi2ndof">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.root_files.</span></span><span class="sig-name descname"><span class="pre">compute_endvertex_chi2ndof</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataframe</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_particles</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">['Dst']</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/root_files.html#compute_endvertex_chi2ndof"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.root_files.compute_endvertex_chi2ndof" title="Permalink to this definition"></a></dt>
<dd><p>Compute the variable
<code class="docutils literal notranslate"><span class="pre">ENDVERTEX_CHI2NDOF</span> <span class="pre">=</span> <span class="pre">ENDVERTEX_CHI2</span> <span class="pre">/</span> <span class="pre">ENDVERTEX_CHI2NDOF</span></code>
for a list of particles. In-place. Add the variable to the
sample under the name <code class="docutils literal notranslate"><span class="pre">{particle_alias}_{ENDVERTEX_CHI2NDOF}</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – sample</p></li>
<li><p><strong>list_particles</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – list of particles which the variable
<code class="docutils literal notranslate"><span class="pre">ENDVERTEX_CHI2NDOF</span></code> is computed.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.root_files.isolate_multiple_cat">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.root_files.</span></span><span class="sig-name descname"><span class="pre">isolate_multiple_cat</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">sample</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dict_shared_feature_flags_mults</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">get</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cat'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/root_files.html#isolate_multiple_cat"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.root_files.isolate_multiple_cat" title="Permalink to this definition"></a></dt>
<dd><p>Isolate the category of multiple candidates given through
the requirement <code class="docutils literal notranslate"><span class="pre">multiple_candidates_cat.req_cat_mul_candidates</span></code></p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>sample</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – dataframe</p></li>
<li><p><strong>dict_shared_feature_flags_mults</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">Dict</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>]) – Associates a candidate multiplicity
with a dataframe whose columns are particle flags
(which indicate if the particle is shared) or not
between 2 combinations of candidates</p></li>
<li><p><strong>get</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – whether to get only the category (<cite>cat</cite>), or the candidates
that don’t belong to this category (<cite>non_cat</cite>) or both
(<cite>both</cite>)</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>, <code class="xref py py-data docutils literal notranslate"><span class="pre">Tuple</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>]]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><ul class="simple">
<li><p>sample_cat: multiple candidates corresponding to the desired             category</p></li>
<li><p>sample_non_cat: other candidates</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.root_files.load_process_all_samples">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.root_files.</span></span><span class="sig-name descname"><span class="pre">load_process_all_samples</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">list_sample_types</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">flavour</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_loaded_columns</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">indir</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'/eos/lhcb/user/a/anthonyc/R_eMu/CentralProduction5_-1files/selection'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/root_files.html#load_process_all_samples"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.root_files.load_process_all_samples" title="Permalink to this definition"></a></dt>
<dd><p>Load and process samples</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>list_sample_types</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – list of the sample types to load</p></li>
<li><p><strong>flavour</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – flavour to load (<code class="docutils literal notranslate"><span class="pre">Electron</span></code> or <code class="docutils literal notranslate"><span class="pre">Mu</span></code>)</p></li>
<li><p><strong>indir</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – directory where all the ROOT files are located</p></li>
<li><p><strong>list_loaded_columns</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]]) – list of the columns that are loaded</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">Dict</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>associates a sample type with a sample that is processed
and contains the necessary samples</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.root_files.open_dataframes">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.root_files.</span></span><span class="sig-name descname"><span class="pre">open_dataframes</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">folder_path</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">file_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_years</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_magnets</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_columns</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tree_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'selected_tree'</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/root_files.html#open_dataframes"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.root_files.open_dataframes" title="Permalink to this definition"></a></dt>
<dd><p>Open ROOT files for every year and magnet polarisation, using uproot4.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>file_path</strong> – path where the ROOT files are located.</p></li>
<li><p><strong>file_name</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – name of the ROOT files, with wildcards <cite>{y}</cite> for the
years, and <cite>{m}</cite> for months.</p></li>
<li><p><strong>list_years</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]]) – list of years (default are 2016, 2017 and 2018)</p></li>
<li><p><strong>list_magnets</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]]) – list of magnets (default are <cite>U</cite> and <cite>D</cite>)</p></li>
<li><p><strong>list_columns</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]]) – list of columns to load. By default, load every columns</p></li>
<li><p><strong>tree_name</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – tree name in the ROOT file</p></li>
<li><p><strong>verbose</strong> – whether to show the paths of the files that are loaded</p></li>
<li><p><strong>compl_mode</strong> – if set to <cite>True</cite>, <cite>list_columns</cite> are the columns
not to load.</p></li>
<li><p><strong>reset_index</strong> – reset the indices of the resulting dataframe</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>concatenated dataframe of all the dataframes.
Contains 2 new columns <cite>year</cite> and <cite>magnet</cite>.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.root_files.process_sample">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.root_files.</span></span><span class="sig-name descname"><span class="pre">process_sample</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">sample</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_columns_to_compute</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/root_files.html#process_sample"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.root_files.process_sample" title="Permalink to this definition"></a></dt>
<dd><p>Process a sample. In-place.</p>
<ul class="simple">
<li><p>compute columns</p></li>
<li><p>add the <code class="docutils literal notranslate"><span class="pre">EVENT_COLUMN</span></code></p></li>
<li><p>compute <code class="docutils literal notranslate"><span class="pre">B_ENDVERTEX_CHI2NDOF</span></code></p></li>
</ul>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>sample</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – pandas DataFrame</p></li>
<li><p><strong>list_columns_to_compute</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]]) – list of the columns to compute
using <a class="reference internal" href="lib.handle.html#lib.handle.handle_sample.compute_columns" title="lib.handle.handle_sample.compute_columns"><code class="xref py py-func docutils literal notranslate"><span class="pre">lib.handle.handle_sample.compute_columns()</span></code></a>.
If not given, taken to be
<code class="docutils literal notranslate"><span class="pre">definition.loaded_columns.list_columns_to_compute</span></code></p></li>
</ul>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-scripts.multiple_candidates.mulcan.strategy">
<span id="scripts-multiple-candidates-mulcan-strategy-module"></span><h2>scripts.multiple_candidates.mulcan.strategy module<a class="headerlink" href="#module-scripts.multiple_candidates.mulcan.strategy" title="Permalink to this heading"></a></h2>
<p>Module that defines the class <code class="docutils literal notranslate"><span class="pre">MucStrat</span></code> that allows to cook up
the name of the output subfolder according to</p>
<dl class="py class">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.strategy.</span></span><span class="sig-name descname"><span class="pre">MucStrat</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">muc_strat</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">params</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/strategy.html#MucStrat"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></p>
<p>Class to deal with strategies and their subfolders and names.</p>
<dl class="py attribute">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.muc_strat">
<span class="sig-name descname"><span class="pre">muc_strat</span></span><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.muc_strat" title="Permalink to this definition"></a></dt>
<dd><p>strategy (<code class="docutils literal notranslate"><span class="pre">sc</span></code>, <code class="docutils literal notranslate"><span class="pre">random</span></code> or <code class="docutils literal notranslate"><span class="pre">opt</span></code>)</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.params">
<span class="sig-name descname"><span class="pre">params</span></span><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.params" title="Permalink to this definition"></a></dt>
<dd><p>parameters of the strategy (e.g., <code class="docutils literal notranslate"><span class="pre">seed</span></code> for <code class="docutils literal notranslate"><span class="pre">random</span></code>)</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.from_full_muc_strat">
<em class="property"><span class="pre">static</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">from_full_muc_strat</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">full_muc_strat</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/strategy.html#MucStrat.from_full_muc_strat"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.from_full_muc_strat" title="Permalink to this definition"></a></dt>
<dd><p>Define <code class="docutils literal notranslate"><span class="pre">MucStrat</span></code> from the full strategy <code class="docutils literal notranslate"><span class="pre">full_muc_strat</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>full_muc_strat</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – a string that indicates the strategy of
selection of multiple candidates.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.from_subfolder">
<em class="property"><span class="pre">static</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">from_subfolder</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">subfolder</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/strategy.html#MucStrat.from_subfolder"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.from_subfolder" title="Permalink to this definition"></a></dt>
<dd><p>Define <code class="docutils literal notranslate"><span class="pre">MucStrat</span></code> from the subfolder.</p>
<dl class="simple">
<dt>subfolder: Subfolder for a given multiple candidate</dt><dd><p>selection strategy. It must be a value of the dictionnary
<code class="docutils literal notranslate"><span class="pre">dict_muc_strat_to_subfolder</span></code>.</p>
</dd>
</dl>
</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.full_muc_strat">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">full_muc_strat</span></span><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.full_muc_strat" title="Permalink to this definition"></a></dt>
<dd><p><code class="docutils literal notranslate"><span class="pre">full_muc_strat_wildcards</span></code> where the parameter names are
replaced by their values.</p>
</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.full_muc_strat_wildcards">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">full_muc_strat_wildcards</span></span><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.full_muc_strat_wildcards" title="Permalink to this definition"></a></dt>
<dd><p>A string that indicates the strategy of selection of
multiple candidates.</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">sc</span></code>: all the multiple candidates are removed</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">random_{seed}</span></code>: one single candidate is selected for every         multiple events, with random seed <cite>{seed}</cite></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">opt_{opt_best}_{opt_column}</span></code>: one single candidate is         selected, that is, the one that minimises         (<code class="docutils literal notranslate"><span class="pre">opt_best</span> <span class="pre">==</span> <span class="pre">&quot;min&quot;</span></code>) or maximises (<code class="docutils literal notranslate"><span class="pre">opt_best</span> <span class="pre">==</span> <span class="pre">&quot;max&quot;</span></code>)          the column <code class="docutils literal notranslate"><span class="pre">opt_column</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">None</span></code>: all the multiple candidates are kept</p></li>
</ul>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.get_param">
<span class="sig-name descname"><span class="pre">get_param</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/strategy.html#MucStrat.get_param"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.get_param" title="Permalink to this definition"></a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.get_shell_arguments">
<em class="property"><span class="pre">static</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">get_shell_arguments</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">subfolder</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/strategy.html#MucStrat.get_shell_arguments"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.get_shell_arguments" title="Permalink to this definition"></a></dt>
<dd><p>Get the shell arguments to pass to the script
<code class="docutils literal notranslate"><span class="pre">a_select_multiple_candidates/run.py</span></code> that corresponds to the
subfolder <code class="docutils literal notranslate"><span class="pre">subfolder</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>subfolder</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – Subfolder for a given multiple candidate
selection strategy. It must be a value of the dictionnary
<code class="docutils literal notranslate"><span class="pre">dict_muc_strat_to_subfolder</span></code>.</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>string correspond to the passed shell arguments</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">MucStrat</span><span class="o">.</span><span class="n">get_shell_arguments</span><span class="p">(</span><span class="s2">&quot;mulcan/random-20/&quot;</span><span class="p">)</span>
<span class="go">&quot;-strat random -s 20&quot;</span>
</pre></div>
</div>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.get_subfolder_from_full_muc_strat">
<em class="property"><span class="pre">static</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">get_subfolder_from_full_muc_strat</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">full_muc_strat</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/mulcan/strategy.html#MucStrat.get_subfolder_from_full_muc_strat"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.get_subfolder_from_full_muc_strat" title="Permalink to this definition"></a></dt>
<dd><p>Get the subfolder name from <code class="docutils literal notranslate"><span class="pre">full_muc_strat</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>full_muc_strat</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – <p>a string that indicates the strategy of
selection of multiple candidates.</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">sc</span></code>: all the multiple candidates are removed</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">random_{seed}</span></code>: one single candidate is selected for                 every multiple events, with random seed <code class="docutils literal notranslate"><span class="pre">{seed}</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">opt_{opt_best}_{opt_column}</span></code>: one single candidate is                 selected, that is, the one that minimises                 (<code class="docutils literal notranslate"><span class="pre">opt_best</span> <span class="pre">==</span> <span class="pre">&quot;min&quot;</span></code>)                 or maximises (<code class="docutils literal notranslate"><span class="pre">opt_best</span> <span class="pre">==</span> <span class="pre">&quot;max&quot;</span></code>)                 the column <code class="docutils literal notranslate"><span class="pre">opt_column</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">None</span></code>: all the multiple candidates are kept</p></li>
</ul>
</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Subfolder for a given multiple candidate
selection strategy. It must be a value of the dictionnary
<code class="docutils literal notranslate"><span class="pre">dict_muc_strat_to_subfolder</span></code>.</p>
</dd>
</dl>
</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.subfolder">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">subfolder</span></span><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.subfolder" title="Permalink to this definition"></a></dt>
<dd><p>Subfolder for the given multiple candidate strategy.</p>
</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.MucStrat.subfolder_wildcards">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">subfolder_wildcards</span></span><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.MucStrat.subfolder_wildcards" title="Permalink to this definition"></a></dt>
<dd><p>Subfolder with parameters as wildcards</p>
</dd></dl>

</dd></dl>

<dl class="py data">
<dt class="sig sig-object py" id="scripts.multiple_candidates.mulcan.strategy.dict_muc_strat_to_full_muc_strat_wildcards">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.mulcan.strategy.</span></span><span class="sig-name descname"><span class="pre">dict_muc_strat_to_full_muc_strat_wildcards</span></span><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">{'opt':</span> <span class="pre">'opt-{opt_best}-{opt_column}',</span> <span class="pre">'random':</span> <span class="pre">'random-{base_seed}',</span> <span class="pre">'sc':</span> <span class="pre">'sc'}</span></em><a class="headerlink" href="#scripts.multiple_candidates.mulcan.strategy.dict_muc_strat_to_full_muc_strat_wildcards" title="Permalink to this definition"></a></dt>
<dd><p>Associates a <code class="docutils literal notranslate"><span class="pre">muc_strat</span></code> with a <code class="docutils literal notranslate"><span class="pre">full</span> <span class="pre">muc_strategy</span></code> with wildcards</p>
</dd></dl>

</div>
</div>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="scripts.multiple_candidates.definition.html" class="btn btn-neutral float-left" title="scripts.multiple_candidates.definition package" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="scripts.multiple_candidates.scripts_ana.html" class="btn btn-neutral float-right" title="scripts.multiple_candidates.scripts_ana package" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>